/**
 * \file CanBasicDemo.h
 * \brief Demo CanBasicDemo
 *
 * \version iLLD_Demos_1_0_1_10_0
 * \copyright Copyright (c) 2014 Infineon Technologies AG. All rights reserved.
 *
 *
 *                                 IMPORTANT NOTICE
 *
 *
 * Infineon Technologies AG (Infineon) is supplying this file for use
 * exclusively with Infineon's microcontroller products. This file can be freely
 * distributed within development tools that are supporting such microcontroller
 * products.
 *
 * THIS SOFTWARE IS PROVIDED "AS IS".  NO WARRANTIES, WHETHER EXPRESS, IMPLIED
 * OR STATUTORY, INCLUDING, BUT NOT LIMITED TO, IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE APPLY TO THIS SOFTWARE.
 * INFINEON SHALL NOT, IN ANY CIRCUMSTANCES, BE LIABLE FOR SPECIAL, INCIDENTAL,
 * OR CONSEQUENTIAL DAMAGES, FOR ANY REASON WHATSOEVER.
 *
 * \defgroup IfxLld_Demo_CanBasic_SrcDoc_Main Demo Source
 * \ingroup IfxLld_Demo_CanBasic_SrcDoc
 * \defgroup IfxLld_Demo_CanBasic_SrcDoc_Main_Interrupt Interrupts
 * \ingroup IfxLld_Demo_CanBasic_SrcDoc_Main
 */

#ifndef CANBASICDEMO_H
#define CANBASICDEMO_H 1

/******************************************************************************/
/*----------------------------------Includes----------------------------------*/
/******************************************************************************/

#include <Ifx_Types.h>
#include "Configuration.h"

#include <Can/Can/IfxCan_Can.h>


#define TESTED_NODES 2

/******************************************************************************/
/*-----------------------------------Macros-----------------------------------*/
/******************************************************************************/
#define ISR_PRIORITY_CAN1_TX 0x3D
#define ISR_PRIORITY_CAN0_RX 0x30

/******************************************************************************/
/*--------------------------------Enumerations--------------------------------*/
/******************************************************************************/

/******************************************************************************/
/*-----------------------------Data Structures--------------------------------*/
/******************************************************************************/

/** \brief Can information */
typedef struct
{
    struct
    {
        IfxCan_Can can[2];                     /**< \brief CAN handle */
		IfxCan_Can_Node canNode[TESTED_NODES];    /**< \brief CAN Node handles */
    }         drivers;

    Ifx_SizeT count;
} App_CanBasic;

/******************************************************************************/
/*------------------------------Global variables------------------------------*/
/******************************************************************************/

IFX_EXTERN App_CanBasic g_CanBasic;

/******************************************************************************/
/*-------------------------Function Prototypes--------------------------------*/
/******************************************************************************/

IFX_EXTERN void CanBasicDemo_init(void);
IFX_EXTERN void CanBasicDemo_run(void);

#endif
